/****************************************/
/* MES/Copyleft Yukio Mituiwa,2005	*/
/*					*/
/*  2005/2/14 first release		*/
/*  2005/10/08 A.Takeuchi modified	*/
/****************************************/

#include <stdarg.h>
#include <ctype.h>
#include <string.h>
int stoi(char*);
int stoh(char*);
static int digit(char*, int*);
static void strrev(char*);
static void itos(int, char*);
static void htos(unsigned int, char*, int);
static char* outchar(char*, int, char);
static char* inchar(char*, int, char*);
static char* readbuf(char*, int, char*, int);
static void __vprintf(va_list*, char*, int, char*,...);
static void __vscanf(va_list*, char*, int, char*,...);

static int digit(char *s, int *n) {
	char	buf[8];
	int	i;

	*n = 0;
	for(i = 0;i < 7;i++) {
		if(!isdigit(s[i])) break;
		buf[i] = s[i];
	}
	buf[i] = 0;
	*n = stoi(buf);
	return i;
}
 
static void strrev(char *s) {
	int	c, i, j, n;

	n = strlen(s);
	for(i = 0,j = n - 1;i < j;i++, j--) {
		c = s[i];
		s[i] = s[j];
		s[j] = c;
	}
}

static void itos(int n, char *s) {
	int	i, sign;

	if((sign = n) < 0) n = -n;
	i = 0;
	do {
		s[i++] = n % 10 + '0';
	} while((n /= 10) > 0);
	if(sign < 0) s[i++] = '-';
	s[i] = 0;
	strrev(s);
}

static void htos(unsigned int n, char *s, int flag) {
	int	i;
	char	c;

	i = 0;
	do {
		c = n & 15;
		s[i++] = ((c < 10) ? '0' : ((flag == 0) ? 'W' : '7')) + c;
	} while((n >>= 4) > 0);
	s[i] = '\0';
	strrev(s);
}

static char* outchar(char *str, int fd, char c) {
	if(str == 0) __write(fd, &c, 1);
	else *str++ = c;
	return str;
}

static char* inchar(char *str, int fd, char *c) {
	if(str == 0) {
		*c = 0;
		if(fd == 0) {
			while(__read(0, c, 1) == 0);
			__write(0, c, 1);
		} else {
			__read(fd, c, 1);
		}
	} else {
		*c = *str++;
	}
	return str;
}

static char* readbuf(char *str, int fd, char *s, int max) {
	int	i;

	for(i = 0;i < max;i++) {
		str = inchar(str, fd, &s[i]);
		if(s[i] <= ' ') break;
	}
	s[i] = 0;
	return str;
}

static void __vprintf(va_list *ap, char *str, int fd, char *fmt, ...) {
	char	*s, *sv, c, sp, mi;		// AT
	char	buf[16];
	int	val, i, n, len, siz;

	while(*fmt) {
		c = *fmt++;
		if(c == '%') {
			sv = fmt;
			mi = *fmt;
			if(mi == '-') fmt++;
			sp = (*fmt == '0') ? '0' : ' ';
			siz = digit(fmt, &n);
			fmt = &fmt[siz];
			c = *fmt++;
			s = buf;
			switch(c) {
			case 's':
			case 'S':
				sp = ' ';
				s = va_arg(*ap, char*);
				break;
			case 'c':
			case 'C':
				sp = ' ';
				buf[0] = va_arg(*ap, int);
				buf[1] = 0;
				break;
			case 'd':
			case 'D':
				val = va_arg(*ap, int);
				itos(val, buf);
				break;
			case 'x':
			case 'X':
				val = va_arg(*ap, int);
				htos(val, buf, (c == 'x') ? 0 : 1);
				break;
			default:
				fmt = sv;
				buf[0] = *fmt++;
				buf[1] = 0;
			}
			len = strlen(s);
			if(mi != '-') for(i = 0;i < (n - len);i++) str = outchar(str, fd, sp);
			for(i = 0;i < len;i++) str = outchar(str, fd, s[i]);
			if(mi == '-') for(i = 0;i < (n - len);i++) str = outchar(str, fd, sp);
		} else {
			str = outchar(str, fd, c);
		}
	}
	c = 0;
	if(str) outchar(str, fd, c);
}

static void __vscanf(va_list *ap, char *str, int fd, char *fmt, ...) {
	char	*s, c, buf[16];
	int	*val, n, siz, cnt;

	while(*fmt) {
		c = *fmt++;
		if(c == '%') {
			siz = digit(fmt, &n);
			fmt = &fmt[siz];
			c = *fmt++;
			switch(c) {
			case 's':
			case 'S':
				s = va_arg(*ap, char*);
				cnt = 0;
				for(;;) {
					str = inchar(str, fd, &c);
					if(str == 0 && fd == 0) {
						if(c == 0x7f) c = 8;
						if(c == '\n' || c == '\r') break;
						if(c == 8) {
							if(cnt > 0) cnt--;
						} else {
							s[cnt++] = c;
						}
					} else {
						s[cnt++] = c;
					}
					if(siz > 0 && cnt >= n) break;
				}
				s[cnt] = 0;
				break;
			case 'c':
			case 'C':
				s = va_arg(*ap, char*);
				str = readbuf(str, fd, buf, 1);
				*s = *buf;
				break;
			case 'd':
			case 'D':
				val = va_arg(*ap, int*);
				str = readbuf(str, fd, buf, 15);
				*val = stoi(buf);
				break;
			case 'x':
			case 'X':
				val = va_arg(*ap, int*);
				str = readbuf(str, fd, buf, 15);
				*val = stoh(buf);
				break;
			}
		}
	}
}

void __printf(char *fmt, ...) {
	va_list	ap;

	va_start(ap, fmt);
	__vprintf(&ap, 0, 0, fmt);
	va_end(ap);
}

void __fprintf(int fd, char *fmt, ...) {
	va_list	ap;

	va_start(ap, fmt);
	__vprintf(&ap, 0, fd, fmt);
	va_end(ap);
}

void __sprintf(char *str, char *fmt, ...) {
	va_list	ap;

	va_start(ap, fmt);
	__vprintf(&ap, str, 0, fmt);
	va_end(ap);
}

void __scanf(char *fmt, ...) {
	va_list	ap;

	va_start(ap, fmt);
	__vscanf(&ap, 0, 0, fmt);
	va_end(ap);
}

void __fscanf(int fd, char *fmt, ...) {
	va_list	ap;

	va_start(ap, fmt);
	__vscanf(&ap, 0, fd, fmt);
	va_end(ap);
}

void __sscanf(char *str, char *fmt, ...) {
	va_list	ap;

	va_start(ap, fmt);
	__vscanf(&ap, str, 0, fmt);
	va_end(ap);
}

int __fputc(int fd, int c) {
	char	buf;

	buf = c;
	__write(fd, &buf, 1);
	return c;
}

int __fgetc(int fd) {
	char	buf;

	while(__read(fd, &buf, 1) == 0);
	return buf & 0xff;
}

int __putchar(int c) {
	char	buf;

	buf = c;
	__write(0, &buf, 1);
	return c;
}

int __getchar() {
	char	buf;

	while(__read(0, &buf, 1) == 0);
	return buf & 0xff;
}

