#include <mes2.h>

#define TYPE_A	1
#define TYPE_CNAME	5
#define CLASS_IN	1
#define BUFSIZ	1400

static int skip_name(char *buf, int index) {
	while(buf[index] != 0) {
		if((buf[index] & 0xc0) == 0xc0) {
			index++;
			break;
		}
		index++;
	}
	index++;
	return index;
}

static unsigned int dns(char *name) {
	struct sockaddr	addr, from;
	int		sock, ret;
	unsigned int	dst, src, dstnum, size, n, i, index;
	unsigned int	word, ansnum, type, class, ip, retry, dns;
	unsigned char	c, *bp, *buf;

	dns = dns_server(0);
	if(dns == 0) return 0;
	buf = malloc(BUFSIZ);
	if(buf == 0) return 0;
	sock = udp_socket();
	if(sock == -1) {
		free(buf);
		return 0;
	}
	addr.sin_addr = dns;
	addr.sin_port = 53;
	udp_bind(sock, &addr);
	buf[0] = 0x12; buf[1] = 0x34;
	buf[2] = 0x01; buf[3] = 0x00;
	buf[4] = 0x00; buf[5] = 0x01;
	buf[6] = 0x00; buf[7] = 0x00;
	buf[8] = 0x00; buf[9] = 0x00;
	buf[10] = 0x00; buf[11] = 0x00;
	bp = &buf[12];
	dst = 1;
	dstnum = 0;
	src = 0;
	size = 0;
	while(name[src] != 0) {
		c = name[src++];
		if(c == '.') {
			bp[dstnum] = size;
			dstnum = dst++;
			size = 0;
		} else {
			bp[dst++] = c;
			size++;
		}
	}
	bp[dstnum] = size;
	bp[dst++] = 0;
	bp = &bp[dst];
	*(bp++) = TYPE_A >> 8;
	*(bp++) = TYPE_A;
	*(bp++) = CLASS_IN >> 8;
	*(bp++) = CLASS_IN;
	size = strlen(name) + 2 + sizeof(short) * 8;
	ret=0;	// AT
	for(retry = 0;retry < 4;retry++) {
		sendto(sock, buf, size, &addr);
		bzero(buf, BUFSIZ);
		ret = recvfrom(sock, buf, BUFSIZ, &from);
		if(ret > 0) break;
		sleep(1500);
	}
	udp_free(sock);
	if(ret <= 0) {
		free(buf);
		return 0;
	}
	word = buf[0] << 8;
	word |= buf[1];
	if(word != 0x1234) {
		free(buf);
		return 0;
	}
	word = buf[2] << 8;
	word |= buf[3];
	if((word & 0x8180) != 0x8180) {
		free(buf);
		return 0;
	}
	if(word & 0x000f) {
		free(buf);
		return 0;
	}
	ansnum = buf[6] << 8;
	ansnum |= buf[7];
	index = skip_name(buf, 12);
	index += 4;
	for(i = 0;i < ansnum;i++) {
		if(index > (BUFSIZ - 100)) {
			free(buf);
			return 0;
		}
		index = skip_name(buf, index);
		type = buf[index++] << 8;
		type |= buf[index++];
		class = buf[index++] << 8;
		class |= buf[index++];
		index += 4;
		size = buf[index++] << 8;
		size |= buf[index++];
		if(type == TYPE_A) {
			ip = buf[index++];
			ip <<= 8;
			ip |= buf[index++];
			ip <<= 8;
			ip |= buf[index++];
			ip <<= 8;
			ip |= buf[index++];
			free(buf);
			return ip;
		}
		index += size;
	}
	free(buf);
	return 0;
}

int strtoip(char *ptr, int *error) {
	int		i, j, s;
	unsigned int	ip, n;

	*error = 0;
	ip = 0;
	s = 0;
	for(i = 0;i < 4;i++) {
		n = 0;
		for(j = 0;j < 3;j++) {
			if(!isdigit(ptr[s])) {
				*error = -1;
				return 0;
			}
			n = n * 10;
			n += ptr[s++] - '0';
			if(ptr[s] == '.' || (ptr[s] <= ' ' && i == 3)) {
				break;
			}
		}
		s++;
		ip <<= 8;
		ip += n;
	}
	return ip;
}

int gethostbyname(char *name) {
	int	ret, retry, err;

	ret = strtoip(name, &err);
	if(err == 0) return ret;
	for(retry = 0;retry < 3;retry++) {
		ret = dns(name);
		if(ret != 0) return ret;
	}
	return 0;
}
